Index: /branches/network/src/lib/graphics/graphics_engine.h
===================================================================
--- /branches/network/src/lib/graphics/graphics_engine.h	(revision 6741)
+++ /branches/network/src/lib/graphics/graphics_engine.h	(revision 6742)
@@ -22,4 +22,5 @@
 class SubString;
 class WorldEntity;
+class GraphicsEffect;
 
 //! class to handle graphics
@@ -82,4 +83,9 @@
     void process(const Event  &event);
 
+    void loadGraphicsEffect(GraphicsEffect* effect);
+    void unloadGraphicsEffect(GraphicsEffect* effect);
+
+
+
   private:
     GraphicsEngine();
@@ -91,36 +97,39 @@
 
   private:
-    static GraphicsEngine*  singletonRef;       //!< Pointer to the only instance of this Class
-    bool                    isInit;             //!< if the GraphicsEngine is initialized.
+    static GraphicsEngine*     singletonRef;       //!< Pointer to the only instance of this Class
+    bool                       isInit;             //!< if the GraphicsEngine is initialized.
 
     // state.
-    SDL_Surface*            screen;             //!< the screen we draw to
-    int                     resolutionX;        //!< the X-resoultion of the screen
-    int                     resolutionY;        //!< the Y-resolution of the screen
-    int                     bitsPerPixel;       //!< the bits per pixels of the screen
-    Uint32                  fullscreenFlag;     //!< if we are in fullscreen mode
-    Uint32                  videoFlags;         //!< flags for video
-    SDL_Rect**              videoModes;         //!< list of resolutions
+    SDL_Surface*               screen;             //!< the screen we draw to
+    int                        resolutionX;        //!< the X-resoultion of the screen
+    int                        resolutionY;        //!< the Y-resolution of the screen
+    int                        bitsPerPixel;       //!< the bits per pixels of the screen
+    Uint32                     fullscreenFlag;     //!< if we are in fullscreen mode
+    Uint32                     videoFlags;         //!< flags for video
+    SDL_Rect**                 videoModes;         //!< list of resolutions
 
-    bool                    fogEnabled;         //!< If Fog should be enabled.
-    bool                    shadowsEnabled;     //!< If Shadows should be enabled.
-    bool                    particlesEnabled;   //!< If particles should be enabled.
-    int                     particlesValue;     //!< How many particles
-    int                     textureQuality;     //!< the quality of Textures
-    int                     filteringMethod;    //!< The filtering Method of textures.
-    int                     modelQuality;       //!< The quality of the Models loaded.
-    int                     antialiasingDepth;  //!< the Depth of the AntiAlias-Filter.
+    bool                       fogEnabled;         //!< If Fog should be enabled.
+    bool                       shadowsEnabled;     //!< If Shadows should be enabled.
+    bool                       particlesEnabled;   //!< If particles should be enabled.
+    int                        particlesValue;     //!< How many particles
+    int                        textureQuality;     //!< the quality of Textures
+    int                        filteringMethod;    //!< The filtering Method of textures.
+    int                        modelQuality;       //!< The quality of the Models loaded.
+    int                        antialiasingDepth;  //!< the Depth of the AntiAlias-Filter.
 
     // HARDWARE-Settings:
-    char*                   hwRenderer;         //!< HW-renderer-string
-    char*                   hwVendor;           //!< HW-vendor-string
-    char*                   hwVersion;          //!< HW-version-string
-    SubString*              hwExtensions;       //!< All suported Extensions.
+    char*                      hwRenderer;         //!< HW-renderer-string
+    char*                      hwVendor;           //!< HW-vendor-string
+    char*                      hwVersion;          //!< HW-version-string
+    SubString*                 hwExtensions;       //!< All suported Extensions.
 
     // FPS-related
-    bool                    bDisplayFPS;        //!< is true if the fps should be displayed
-    float                   currentFPS;         //!< the current frame rate: frames per seconds
-    float                   maxFPS;             //!< maximal frame rate we ever got since start of the game
-    float                   minFPS;             //!< minimal frame rate we ever got since start.
+    bool                       bDisplayFPS;        //!< is true if the fps should be displayed
+    float                      currentFPS;         //!< the current frame rate: frames per seconds
+    float                      maxFPS;             //!< maximal frame rate we ever got since start of the game
+    float                      minFPS;             //!< minimal frame rate we ever got since start.
+
+    std::list<GraphicsEffect*> graphicsEffects;    //!< list of graphics effects
+
 
 #ifndef NO_TEXT
Index: /branches/network/src/lib/network/synchronizeable.cc
===================================================================
--- /branches/network/src/lib/network/synchronizeable.cc	(revision 6741)
+++ /branches/network/src/lib/network/synchronizeable.cc	(revision 6742)
@@ -35,5 +35,5 @@
 {
   this->setClassID(CL_SYNCHRONIZEABLE, "Synchronizeable");
-  this->owner = 0;
+  this->owner = -1;
   this->state = 0;
   this->hostID = SharedNetworkData::getInstance()->getHostID();