Index: code/trunk/src/orxonox/CameraManager.h
===================================================================
--- code/trunk/src/orxonox/CameraManager.h	(revision 6731)
+++ code/trunk/src/orxonox/CameraManager.h	(revision 6746)
@@ -61,6 +61,4 @@
             void useCamera(Ogre::Camera* camera);
 
-            static CameraManager* getInstancePtr() { return singletonPtr_s; }
-
         private:
             CameraManager(const CameraManager&); // don't use
Index: code/trunk/src/orxonox/Level.cc
===================================================================
--- code/trunk/src/orxonox/Level.cc	(revision 6731)
+++ code/trunk/src/orxonox/Level.cc	(revision 6746)
@@ -58,5 +58,5 @@
         if (this->isInitialized())
         {
-            if (LevelManager::getInstancePtr())
+            if (LevelManager::exists())
                 LevelManager::getInstance().releaseActivity(this);
 
@@ -116,5 +116,5 @@
             (*it)->setGametype(rootgametype);
 
-        if (LevelManager::getInstancePtr())
+        if (LevelManager::exists())
             LevelManager::getInstance().requestActivity(this);
     }
Index: code/trunk/src/orxonox/LevelManager.h
===================================================================
--- code/trunk/src/orxonox/LevelManager.h	(revision 6731)
+++ code/trunk/src/orxonox/LevelManager.h	(revision 6746)
@@ -62,5 +62,4 @@
             const std::string& getAvailableLevelListItem(unsigned int index) const; //tolua_export
 
-            static LevelManager* getInstancePtr() { return singletonPtr_s; }
             static LevelManager& getInstance()    { return Singleton<LevelManager>::getInstance(); } // tolua_export
 
Index: code/trunk/src/orxonox/PlayerManager.cc
===================================================================
--- code/trunk/src/orxonox/PlayerManager.cc	(revision 6731)
+++ code/trunk/src/orxonox/PlayerManager.cc	(revision 6746)
@@ -66,5 +66,5 @@
             this->clients_[clientID] = player;
 
-            if (LevelManager::getInstancePtr() && LevelManager::getInstance().getActiveLevel())
+            if (LevelManager::exists() && LevelManager::getInstance().getActiveLevel())
                 LevelManager::getInstance().getActiveLevel()->playerEntered(player);
         }
@@ -82,5 +82,5 @@
             this->clients_.erase(clientID);
 
-            if (LevelManager::getInstancePtr() && LevelManager::getInstance().getActiveLevel())
+            if (LevelManager::exists() && LevelManager::getInstance().getActiveLevel())
                 LevelManager::getInstance().getActiveLevel()->playerLeft(player);
 
Index: code/trunk/src/orxonox/gamestates/GSLevel.cc
===================================================================
--- code/trunk/src/orxonox/gamestates/GSLevel.cc	(revision 6731)
+++ code/trunk/src/orxonox/gamestates/GSLevel.cc	(revision 6746)
@@ -69,14 +69,14 @@
         {
             gameInputState_ = InputManager::getInstance().createInputState("game");
-            gameInputState_->setMouseMode(MouseMode::Exclusive);
+            gameInputState_->setMouseExclusive(TriBool::True);
             gameInputState_->setHandler(KeyBinderManager::getInstance().getDefaultAsHandler());
             KeyBinderManager::getInstance().setToDefault();
 
             guiMouseOnlyInputState_ = InputManager::getInstance().createInputState("guiMouseOnly");
-            guiMouseOnlyInputState_->setMouseMode(MouseMode::Exclusive);
-            guiMouseOnlyInputState_->setMouseHandler(GUIManager::getInstancePtr());
+            guiMouseOnlyInputState_->setMouseExclusive(TriBool::True);
+            guiMouseOnlyInputState_->setMouseHandler(&GUIManager::getInstance());
 
             guiKeysOnlyInputState_ = InputManager::getInstance().createInputState("guiKeysOnly");
-            guiKeysOnlyInputState_->setKeyHandler(GUIManager::getInstancePtr());
+            guiKeysOnlyInputState_->setKeyHandler(&GUIManager::getInstance());
         }
 
Index: code/trunk/src/orxonox/gamestates/GSMainMenu.cc
===================================================================
--- code/trunk/src/orxonox/gamestates/GSMainMenu.cc	(revision 6731)
+++ code/trunk/src/orxonox/gamestates/GSMainMenu.cc	(revision 6746)
@@ -31,6 +31,4 @@
 #include <OgreSceneManager.h>
 
-#include "core/input/InputManager.h"
-#include "core/input/InputState.h"
 #include "core/input/KeyBinderManager.h"
 #include "core/Game.h"
@@ -42,4 +40,7 @@
 #include "Scene.h"
 #include "sound/AmbientSound.h"
+// HACK
+#include "core/input/InputManager.h"
+#include "core/input/InputState.h"
 
 namespace orxonox
@@ -49,12 +50,8 @@
     GSMainMenu::GSMainMenu(const GameStateInfo& info)
         : GameState(info)
-        , inputState_(0)
     {
         RegisterRootObject(GSMainMenu);
-        inputState_ = InputManager::getInstance().createInputState("mainMenu");
-        inputState_->setMouseMode(MouseMode::Nonexclusive);
-        inputState_->setHandler(GUIManager::getInstancePtr());
-        inputState_->setKeyHandler(KeyBinderManager::getInstance().getDefaultAsHandler());
-        inputState_->setJoyStickHandler(&InputHandler::EMPTY);
+
+        InputManager::getInstance().createInputState("MainMenuHackery")->setKeyHandler(KeyBinderManager::getInstance().getDefaultAsHandler());
 
         // create an empty Scene
@@ -76,5 +73,5 @@
             this->ambient_->destroy();
 
-        InputManager::getInstance().destroyState("mainMenu");
+        InputManager::getInstance().destroyState("MainMenuHackery");
 
         this->scene_->getSceneManager()->destroyCamera(this->camera_);
@@ -85,9 +82,10 @@
     {
         // show main menu
-        GUIManager::getInstance().showGUI("MainMenu", true, GraphicsManager::getInstance().isFullScreen());
+        GUIManager::getInstance().showGUI("MainMenu", true);
         GUIManager::getInstance().setCamera(this->camera_);
-        GUIManager::getInstance().setBackground("MainMenuBackground");
-//         GUIManager::getInstance().setBackground("");
+        GUIManager::getInstance().setBackgroundImage("MainMenuBackground", "Background");
         GraphicsManager::getInstance().setCamera(this->camera_);
+
+        InputManager::getInstance().enterState("MainMenuHackery");
 
         CommandExecutor::addConsoleCommandShortcut(createConsoleCommand(createFunctor(&GSMainMenu::startStandalone), "startGame"));
@@ -101,5 +99,4 @@
 
         KeyBinderManager::getInstance().setToDefault();
-        InputManager::getInstance().enterState("mainMenu");
 
         this->setConfigValues();
@@ -119,8 +116,8 @@
         }
 
-        InputManager::getInstance().leaveState("mainMenu");
+        InputManager::getInstance().leaveState("MainMenuHackery");
 
         GUIManager::getInstance().setCamera(0);
-        GUIManager::getInstance().setBackground("");
+        GUIManager::getInstance().setBackgroundImage("");
         GUIManager::hideGUI("MainMenu");
         GraphicsManager::getInstance().setCamera(0);
Index: code/trunk/src/orxonox/gamestates/GSMainMenu.h
===================================================================
--- code/trunk/src/orxonox/gamestates/GSMainMenu.h	(revision 6731)
+++ code/trunk/src/orxonox/gamestates/GSMainMenu.h	(revision 6746)
@@ -61,5 +61,4 @@
 
     private:
-        InputState*       inputState_;
         Scene*            scene_;
         Ogre::Camera*     camera_;
Index: code/trunk/src/orxonox/overlays/CMakeLists.txt
===================================================================
--- code/trunk/src/orxonox/overlays/CMakeLists.txt	(revision 6731)
+++ code/trunk/src/orxonox/overlays/CMakeLists.txt	(revision 6746)
@@ -1,3 +1,4 @@
 ADD_SOURCE_FILES(ORXONOX_SRC_FILES
+  GUISheet.cc
   OrxonoxOverlay.cc
   OverlayGroup.cc
Index: code/trunk/src/orxonox/overlays/GUISheet.cc
===================================================================
--- code/trunk/src/orxonox/overlays/GUISheet.cc	(revision 6746)
+++ code/trunk/src/orxonox/overlays/GUISheet.cc	(revision 6746)
@@ -0,0 +1,96 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Reto Grieder
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+#include "GUISheet.h"
+
+#include "core/CoreIncludes.h"
+#include "core/GUIManager.h"
+#include "core/XMLPort.h"
+
+namespace orxonox
+{
+    CreateFactory(GUISheet);
+
+    GUISheet::GUISheet(BaseObject* creator)
+        : BaseObject(creator)
+        , bShowOnLoad_(false)
+        , bHidePrevious_(false)
+        , bHidePreviousSet_(false)
+    {
+        RegisterObject(GUISheet);
+
+        if (!GameMode::showsGraphics())
+            ThrowException(NoGraphics, "GUISheet construction failed: no graphics");
+    }
+
+    GUISheet::~GUISheet()
+    {
+    }
+
+    void GUISheet::XMLPort(Element& xmlElement, XMLPort::Mode mode)
+    {
+        SUPER(GUISheet, XMLPort, xmlElement, mode);
+
+        XMLPortParam(GUISheet, "showOnLoad",   setShowOnLoad,     getShowOnLoad,     xmlElement, mode);
+        XMLPortParam(GUISheet, "hidePrevious", setPreviousHiding, getPreviousHiding, xmlElement, mode);
+        XMLPortParam(GUISheet, "sheetName",    setSheetName,      getSheetName,      xmlElement, mode);
+        XMLPortParam(GUISheet, "backgroundImage",  setBackgroundImage,  getBackgroundImage,  xmlElement, mode);
+
+        if (this->bShowOnLoad_)
+            this->show();
+    }
+
+    void GUISheet::show()
+    {
+        GUIManager::getInstance().setBackgroundImage(this->backgroundImage_);
+        if (this->bHidePreviousSet_)
+            GUIManager::getInstance().showGUI(this->sheetName_, this->bHidePrevious_);
+        else
+            GUIManager::getInstance().showGUI(this->sheetName_);
+    }
+
+    void GUISheet::hide()
+    {
+        GUIManager::getInstance().hideGUI(this->sheetName_);
+        if (!this->backgroundImage_.empty())
+            GUIManager::getInstance().setBackgroundImage("");
+    }
+
+    void GUISheet::setSheetName(const std::string& name)
+    {
+        this->sheetName_ = name;
+        GUIManager::getInstance().loadGUI(this->sheetName_);
+    }
+
+    void GUISheet::setPreviousHiding(bool bHide)
+    {
+        this->bHidePrevious_ = bHide;
+        this->bHidePreviousSet_ = true;
+        // Note: This call has no effect when already showing!
+    }
+}
Index: code/trunk/src/orxonox/overlays/GUISheet.h
===================================================================
--- code/trunk/src/orxonox/overlays/GUISheet.h	(revision 6746)
+++ code/trunk/src/orxonox/overlays/GUISheet.h	(revision 6746)
@@ -0,0 +1,78 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Reto Grieder
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+#ifndef _GUISheet_H__
+#define _GUISheet_H__
+
+#include "OrxonoxPrereqs.h"
+
+#include <string>
+#include "core/BaseObject.h"
+
+namespace orxonox
+{
+    //! Simple XML loadable interface to the otherwise Lua coded GUI framework.
+    class _OrxonoxExport GUISheet : public BaseObject
+    {
+    public:
+        GUISheet(BaseObject* creator);
+        ~GUISheet();
+
+        void XMLPort(Element& xmlElement, XMLPort::Mode mode);
+
+        void show();
+        void hide();
+
+        void setSheetName(const std::string& name);
+        inline const std::string& getSheetName() const
+            { return this->sheetName_; }
+
+        inline void setShowOnLoad(bool bShow)
+            { this->bShowOnLoad_ = bShow; }
+        inline bool getShowOnLoad() const
+            { return this->bShowOnLoad_; }
+
+        void setPreviousHiding(bool bHide);
+        inline bool getPreviousHiding() const
+            { return this->bHidePrevious_; }
+
+        void setBackgroundImage(const std::string& image)
+            { this->backgroundImage_ = image; }
+        inline const std::string& getBackgroundImage() const
+            { return this->backgroundImage_; }
+
+    private:
+        std::string sheetName_;
+        bool bShowOnLoad_;
+        bool bHidePrevious_;
+        bool bHidePreviousSet_;
+        std::string backgroundImage_;
+  };
+}
+
+#endif /* _GUISheet_H__ */