Index: code/trunk/data/gui/scripts/PickupInventory.lua
===================================================================
--- code/trunk/data/gui/scripts/PickupInventory.lua	(revision 6749)
+++ code/trunk/data/gui/scripts/PickupInventory.lua	(revision 6750)
@@ -30,5 +30,5 @@
     
     local root = winMgr:getWindow("orxonox/PickupInventory/Inventory")
-    P.wrapper = winMgr:createWindow("TaharezLook/ScrollablePane", "orxonox/PickupInventory/Inventory/Wrapper")
+    P.wrapper = winMgr:createWindow("MenuWidgets/ScrollablePane", "orxonox/PickupInventory/Inventory/Wrapper")
     P.wrapper:setSize(CEGUI.UVector2(CEGUI.UDim(1,0),CEGUI.UDim(1,0)))
     root:addChildWindow(P.wrapper)
@@ -83,10 +83,10 @@
     local offset = 0
 
-    local box = winMgr:createWindow("TaharezLook/ScrollablePane", name .. "/Box")
+    local box = winMgr:createWindow("MenuWidgets/ScrollablePane", name .. "/Box")
     box:setPosition(CEGUI.UVector2(CEGUI.UDim(0, horizontalOffset), CEGUI.UDim(0, 0)))
     box:setSize(CEGUI.UVector2(CEGUI.UDim(1.0, -horizontalOffset), CEGUI.UDim(1, 0)))
     
     offset = offset+textHeight
-    local title = winMgr:createWindow("TaharezLook/StaticText", name .. "/Title")
+    local title = winMgr:createWindow("MenuWidgets/StaticText", name .. "/Title")
     title:setText(carrier:getCarrierName())
     title:setSize(CEGUI.UVector2(CEGUI.UDim(1, 0), CEGUI.UDim(0, offset)))
@@ -98,5 +98,5 @@
         local pickup = orxonox.PickupManager:getInstance():getPickupRepresentation(i, carrier)
         
-        local item = winMgr:createWindow("TaharezLook/StaticText", name .. "/Box/Pickup" .. i)
+        local item = winMgr:createWindow("MenuWidgets/StaticText", name .. "/Box/Pickup" .. i)
         item:setSize(CEGUI.UVector2(CEGUI.UDim(1, -horizontalOffset), CEGUI.UDim(0, imageHeight)))
         item:setPosition(CEGUI.UVector2(CEGUI.UDim(0, horizontalOffset), CEGUI.UDim(0, offset)))
@@ -104,5 +104,5 @@
         offset = offset + imageHeight+5
         
-        local image = winMgr:createWindow("TaharezLook/StaticImage", name .. "/Box/Pickup" .. i .. "/Image")
+        local image = winMgr:createWindow("MenuWidgets/StaticImage", name .. "/Box/Pickup" .. i .. "/Image")
         image:setProperty("Image", "set:PickupInventory image:" .. pickup:getInventoryRepresentation())
         image:setProperty("BackgroundEnabled", "set:False")
@@ -111,5 +111,5 @@
         item:addChildWindow(image)
         
-        local title = winMgr:createWindow("TaharezLook/StaticText", name .. "/Box/Pickup" .. i .. "/Title")
+        local title = winMgr:createWindow("MenuWidgets/StaticText", name .. "/Box/Pickup" .. i .. "/Title")
         title:setPosition(CEGUI.UVector2(CEGUI.UDim(0, imageHeight+5), CEGUI.UDim(0, (imageHeight-textHeight)/2)))
         title:setSize(CEGUI.UVector2(CEGUI.UDim(0.4, 0), CEGUI.UDim(0, textHeight)))
@@ -118,5 +118,5 @@
         item:addChildWindow(title)
         
-        local useButton = winMgr:createWindow("TaharezLook/Button", name .. "/Box/Pickup" .. i .. "/UseButton")
+        local useButton = winMgr:createWindow("MenuWidgets/Button", name .. "/Box/Pickup" .. i .. "/UseButton")
         useButton:setPosition(CEGUI.UVector2(CEGUI.UDim(0.4, imageHeight+10),CEGUI.UDim(0, (imageHeight-textHeight)/2)))
         useButton:setSize(CEGUI.UVector2(CEGUI.UDim(0, buttonWidth), CEGUI.UDim(0, textHeight)))
@@ -125,5 +125,5 @@
         item:addChildWindow(useButton)
         
-        local dropButton = winMgr:createWindow("TaharezLook/Button", name .. "/Box/Pickup" .. i .. "/DropButton")
+        local dropButton = winMgr:createWindow("MenuWidgets/Button", name .. "/Box/Pickup" .. i .. "/DropButton")
         dropButton:setPosition(CEGUI.UVector2(CEGUI.UDim(0.4, imageHeight+15+buttonWidth),CEGUI.UDim(0, (imageHeight-textHeight)/2)))
         dropButton:setSize(CEGUI.UVector2(CEGUI.UDim(0, buttonWidth), CEGUI.UDim(0, textHeight)))
@@ -132,5 +132,5 @@
         item:addChildWindow(dropButton)
         
-        local detailsButton = winMgr:createWindow("TaharezLook/Button", name .. "/Box/Pickup" .. i .. "/DetailsButton")
+        local detailsButton = winMgr:createWindow("MenuWidgets/Button", name .. "/Box/Pickup" .. i .. "/DetailsButton")
         detailsButton:setPosition(CEGUI.UVector2(CEGUI.UDim(0.4, imageHeight+20+2*buttonWidth),CEGUI.UDim(0, (imageHeight-textHeight)/2)))
         detailsButton:setSize(CEGUI.UVector2(CEGUI.UDim(0, buttonWidth), CEGUI.UDim(0, textHeight)))
@@ -184,5 +184,5 @@
     local name = "orxonox/PickupInventory/Carrier" .. carrierIndex .. "/Pickup" .. pickupIndex .. "/Details" .. P.getNewDetailNumber()
     
-    local window = winMgr:createWindow("TaharezLook/FrameWindow", name)
+    local window = winMgr:createWindow("MenuWidgets/FrameWindow", name)
     window:setSize(CEGUI.UVector2(CEGUI.UDim(0.5,0),CEGUI.UDim(0.4,0)))
     orxonox.GUIManager:subscribeEventHelper(window, "CloseClicked", P.name .. ".closeDetailWindow")
@@ -196,5 +196,5 @@
     window:addChildWindow(wrapper)
     
-    local title = winMgr:createWindow("TaharezLook/StaticText", name .. "/Title")
+    local title = winMgr:createWindow("MenuWidgets/StaticText", name .. "/Title")
     title:setText(pickup:getPickupName())
     title:setHeight(CEGUI.UDim(0, titleHeight))
@@ -203,5 +203,5 @@
     wrapper:addChildWindow(title)
     
-    local image = winMgr:createWindow("TaharezLook/StaticImage", name .. "/Image")
+    local image = winMgr:createWindow("MenuWidgets/StaticImage", name .. "/Image")
     image:setProperty("Image", "set:PickupInventory image:" .. pickup:getInventoryRepresentation())
     image:setProperty("BackgroundEnabled", "set:False")
@@ -211,5 +211,5 @@
     wrapper:addChildWindow(image)
     
-    local box = winMgr:createWindow("TaharezLook/ScrollablePane", name .. "/Description")
+    local box = winMgr:createWindow("MenuWidgets/ScrollablePane", name .. "/Description")
     box:setSize(CEGUI.UVector2(CEGUI.UDim(1.0, -1*(imageSize + 10)),CEGUI.UDim(1, -(titleHeight + 5 + titleHeight + 20))))
     box:setPosition(CEGUI.UVector2(CEGUI.UDim(0, imageSize + 10),CEGUI.UDim(0, titleHeight + 5)))
@@ -221,5 +221,5 @@
     wrapper:addChildWindow(box)
     
-    local useButton = winMgr:createWindow("TaharezLook/Button", name .. "/UseButton")
+    local useButton = winMgr:createWindow("MenuWidgets/Button", name .. "/UseButton")
     useButton:setPosition(CEGUI.UVector2(CEGUI.UDim(0, imageSize+10),CEGUI.UDim(1, -40)))
     useButton:setSize(CEGUI.UVector2(CEGUI.UDim(0, buttonWidth), CEGUI.UDim(0, titleHeight)))
@@ -228,5 +228,5 @@
     wrapper:addChildWindow(useButton)
     
-    local dropButton = winMgr:createWindow("TaharezLook/Button", name .. "/DropButton")
+    local dropButton = winMgr:createWindow("MenuWidgets/Button", name .. "/DropButton")
     dropButton:setPosition(CEGUI.UVector2(CEGUI.UDim(0, imageSize+10+buttonWidth+10),CEGUI.UDim(1, -40)))
     dropButton:setSize(CEGUI.UVector2(CEGUI.UDim(0, buttonWidth), CEGUI.UDim(0, titleHeight)))
@@ -279,5 +279,5 @@
 
 function P.InventoryBackButton_clicked(e)
-    hideGUI("PickupInventory")
+    orxonox.CommandExecutor:execute("OrxonoxOverlay toggleVisibility PickupInventory")
 end
 
Index: code/trunk/data/gui/scripts/SingleplayerMenu.lua
===================================================================
--- code/trunk/data/gui/scripts/SingleplayerMenu.lua	(revision 6749)
+++ code/trunk/data/gui/scripts/SingleplayerMenu.lua	(revision 6750)
@@ -30,5 +30,5 @@
 
 function P.SingleplayerStartButton_clicked(e)
-    choice = winMgr:getWindow("orxonox/SingleplayerLevelListbox"):getFirstSelectedItem()
+    local choice = winMgr:getWindow("orxonox/SingleplayerLevelListbox"):getFirstSelectedItem()
     if choice then
         orxonox.LevelManager:getInstance():setDefaultLevel(choice:getText() .. ".oxw")