Index: trunk/src/world_entities/projectiles/guided_missile.cc
===================================================================
--- trunk/src/world_entities/projectiles/guided_missile.cc	(revision 6759)
+++ trunk/src/world_entities/projectiles/guided_missile.cc	(revision 6760)
@@ -43,5 +43,5 @@
   this->setHealthMax(10);
   this->lifeSpan = 10.0;
-  this->agility = 5;
+  this->agility = 10;
   this->maxVelocity = 75;
 
Index: trunk/src/world_entities/space_ships/space_ship.cc
===================================================================
--- trunk/src/world_entities/space_ships/space_ship.cc	(revision 6759)
+++ trunk/src/world_entities/space_ships/space_ship.cc	(revision 6760)
@@ -143,5 +143,5 @@
   controlVelocityX = 25;
   controlVelocityY = 150;
-  shipInertia = 0.5             ;
+  shipInertia = 1.5             ;
 //  cycle = 0.0;
 
@@ -340,5 +340,5 @@
 
   //orient the spaceship in direction of the mouse
-   rotQuat = Quaternion::quatSlerp( this->getAbsDir(), mouseDir, fabsf(time)*shipInertia);
+   rotQuat = Quaternion::quatSlerp( this->getAbsDir(), mouseDir, 0.5);//fabsf(time)*shipInertia);
    if (this->getAbsDir().distance(rotQuat) > 0.00000000000001)
     this->setAbsDir( rotQuat);
Index: trunk/src/world_entities/weapons/aim.cc
===================================================================
--- trunk/src/world_entities/weapons/aim.cc	(revision 6759)
+++ trunk/src/world_entities/weapons/aim.cc	(revision 6760)
@@ -82,4 +82,5 @@
   this->anim->addKeyFrame(50, .01, ANIM_LINEAR);
 
+
 /*  this->text = new Text();
   this->text->setLayer(this->getLayer());
@@ -114,5 +115,5 @@
     diffVec = ( (*entity)->getAbsCoor() - this->source->getAbsCoor() );
 
-    if ( diffVec.len() < range  &&  acos( (this->source->getAbsDirX()).dot(diffVec)/(diffVec.len() * (this->source->getAbsDirX()).len() ) ) < angle)
+    if ( diffVec.len() < range &&  acos( (this->source->getAbsDirX()).dot(diffVec)/(diffVec.len() * (this->source->getAbsDirX()).len() ) )  < angle)
     {
       //if (this->getParent() != (*entity))
@@ -168,8 +169,9 @@
   diffVec = ( this->getAbsCoor() - this->source->getAbsCoor() );
 //only look for target if the aim hasn`t locked a target yet or if the actual target is out of range
-   if(this->getParent() == PNode::getNullParent() || 
-      diffVec.len() > range  || 
-      ( acos( (this->source->getAbsDirX()).dot(diffVec)/(diffVec.len() * (this->source->getAbsDirX()).len() ) ) > angle))
+   if(this->getParent() == PNode::getNullParent() ||
+      diffVec.len() > range  ||
+     ( acos( (this->source->getAbsDirX()).dot(diffVec)/(diffVec.len() * (this->source->getAbsDirX()).len() ) ) > angle))
     {
+     this->setParentSoft(PNode::getNullParent(),5);
      this->searchTarget();
     }
@@ -195,5 +197,5 @@
 //                &objY,
 //                &objZ );
-//
+//aa
 //   this->setAbsCoor(objX, objY, objZ);
 }
Index: trunk/src/world_entities/weapons/aiming_turret.cc
===================================================================
--- trunk/src/world_entities/weapons/aiming_turret.cc	(revision 6759)
+++ trunk/src/world_entities/weapons/aiming_turret.cc	(revision 6760)
@@ -81,5 +81,5 @@
   animation2->setInfinity(ANIM_INF_CONSTANT);
 
-  this->setStateDuration(WS_SHOOTING, .1);
+  this->setStateDuration(WS_SHOOTING, .9);
   this->setStateDuration(WS_RELOADING, .1);
   this->setStateDuration(WS_ACTIVATING, .4);
@@ -98,6 +98,6 @@
   this->target = new Aim(this);
   this->target->setVisibility(false);
-  this->target->setRange(1000);
-  this->target->setAngle(M_PI_4);
+  this->target->setRange(400);
+  this->target->setAngle(M_PI_2);
 }
 
Index: trunk/src/world_entities/weapons/targeting_turret.cc
===================================================================
--- trunk/src/world_entities/weapons/targeting_turret.cc	(revision 6759)
+++ trunk/src/world_entities/weapons/targeting_turret.cc	(revision 6760)
@@ -93,6 +93,6 @@
   this->target = new Aim(this);
   this->target->setVisibility(false);
-  this->target->setRange(100);
-  this->target->setAngle(M_PI_4/16);
+  this->target->setRange(1000);
+  this->target->setAngle(M_PI_4);
   this->lockedTime = 0;
   this->neededLockTime = 2;