Index: /code/branches/sound5/src/orxonox/MoodManager.h
===================================================================
--- /code/branches/sound5/src/orxonox/MoodManager.h	(revision 6766)
+++ /code/branches/sound5/src/orxonox/MoodManager.h	(revision 6767)
@@ -38,4 +38,11 @@
 namespace orxonox
 {
+    /**
+     * The MoodManager class enables the game to set different themes, i.e. audio themes, each
+     * with a set of different audio files. A theme (called mood) is set by the server and applies to
+     * all clients. Existing moods are currently hard-coded in function checkMoodValidity(). Each mood
+     * needs to have a folder with its name in "data_extern/audo/ambient/" containing sound files named like
+     * the ones in mood "default".
+     */
     class _OrxonoxExport MoodListener : virtual public OrxonoxClass
     {
Index: /code/branches/sound5/src/orxonox/sound/AmbientSound.cc
===================================================================
--- /code/branches/sound5/src/orxonox/sound/AmbientSound.cc	(revision 6766)
+++ /code/branches/sound5/src/orxonox/sound/AmbientSound.cc	(revision 6767)
@@ -23,5 +23,5 @@
  *      Reto Grieder
  *   Co-authors:
- *      ...
+ *      Kevin Young
  *
  */
Index: /code/branches/sound5/src/orxonox/sound/AmbientSound.h
===================================================================
--- /code/branches/sound5/src/orxonox/sound/AmbientSound.h	(revision 6766)
+++ /code/branches/sound5/src/orxonox/sound/AmbientSound.h	(revision 6767)
@@ -22,7 +22,7 @@
  *   Author:
  *      Reto Grieder
+ *      
+ *   Co-authors:
  *      Kevin Young
- *   Co-authors:
- *      ...
  *
  */
@@ -43,6 +43,8 @@
 {
     /**
-     * The AmbientSound class is the base class for all sound file loader classes.
-     * It server as main interface to the OpenAL library.
+     * The AmbientSound class implements the non-3D sound, i.e. sound files that are used for atmospheric
+     * highlighting.
+     * It interfaces with BaseSound and is controllable by MoodManager.
+     * Ambient sounds are always cross-faded. New sounds are registered and activated/deactivated as needed.
      *
      */
Index: /code/branches/sound5/src/orxonox/sound/SoundManager.cc
===================================================================
--- /code/branches/sound5/src/orxonox/sound/SoundManager.cc	(revision 6766)
+++ /code/branches/sound5/src/orxonox/sound/SoundManager.cc	(revision 6767)
@@ -22,8 +22,8 @@
  *   Author:
  *       Erwin 'vaiursch' Herrsche
+ *       
+ *   Co-authors:
  *       Kevin Young
  *       Reto Grieder
- *   Co-authors:
- *      ...
  *
  */
Index: /code/branches/sound5/src/orxonox/sound/SoundManager.h
===================================================================
--- /code/branches/sound5/src/orxonox/sound/SoundManager.h	(revision 6766)
+++ /code/branches/sound5/src/orxonox/sound/SoundManager.h	(revision 6767)
@@ -22,8 +22,8 @@
  *   Author:
  *       Erwin 'vaiursch' Herrsche
+ *       
+ *   Co-authors:
  *       Kevin Young
  *       Reto Grieder
- *   Co-authors:
- *      ...
  */
 
Index: /code/branches/sound5/src/orxonox/weaponsystem/WeaponMode.cc
===================================================================
--- /code/branches/sound5/src/orxonox/weaponsystem/WeaponMode.cc	(revision 6766)
+++ /code/branches/sound5/src/orxonox/weaponsystem/WeaponMode.cc	(revision 6767)
@@ -24,5 +24,5 @@
  *      Fabian 'x3n' Landau
  *   Co-authors:
- *      ...
+ *      Kevin Young
  *
  */
Index: /code/branches/sound5/src/orxonox/weaponsystem/WeaponMode.h
===================================================================
--- /code/branches/sound5/src/orxonox/weaponsystem/WeaponMode.h	(revision 6766)
+++ /code/branches/sound5/src/orxonox/weaponsystem/WeaponMode.h	(revision 6767)
@@ -24,5 +24,5 @@
  *      Fabian 'x3n' Landau
  *   Co-authors:
- *      ...
+ *      Kevin Young
  *
  */
@@ -41,4 +41,9 @@
 namespace orxonox
 {
+    /**
+     * The WeaponMode class enables the developer, amongst other things, to attach a sound file
+     * to the firing event of a weapon. The default firing sound is chosen by each weapon (ex.
+     * HsW01), hard-coded for now.
+     */
     class _OrxonoxExport WeaponMode : public BaseObject
     {