Index: branches/network/src/lib/graphics/effects/fog_effect.cc
===================================================================
--- branches/network/src/lib/graphics/effects/fog_effect.cc	(revision 6776)
+++ branches/network/src/lib/graphics/effects/fog_effect.cc	(revision 6777)
@@ -62,7 +62,8 @@
 void FogEffect::loadParams(const TiXmlElement* root)
 {
+  printf(">>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>.loadParms\n\n");
   GraphicsEffect::loadParams(root);
 
-   LoadParam(root, "fog-effect", this, FogEffect, setFogMode)
+   LoadParam(root, "fog-mode", this, FogEffect, setFogMode)
        .describe("sets the the fog mode {GL_LINEAR, GL_EXP, GL_EXP2}");
 
@@ -87,4 +88,5 @@
 bool FogEffect::activate()
 {
+  printf("fog==============================================>>>>>>>>>>>>>>>>>>>>>>>>...\n\n");
   PRINTF(4)( "Enabling Fog Effect, mode: %i, density: %f, start: %f, end: %f\n", this->fogMode, this->fogDensity,
              this->fogStart, this->fogEnd);
@@ -92,5 +94,5 @@
   glEnable(GL_FOG);
   {
-    GLfloat fogColor[4] = {0.5, 0.5, 0.5, 1.0};
+    GLfloat fogColor[4] = {0.6, 0.6, 0.6, 1.0};
 
     glFogi(GL_FOG_MODE, this->fogMode);
Index: branches/network/src/lib/graphics/effects/graphics_effect.h
===================================================================
--- branches/network/src/lib/graphics/effects/graphics_effect.h	(revision 6776)
+++ branches/network/src/lib/graphics/effects/graphics_effect.h	(revision 6777)
@@ -25,5 +25,5 @@
     virtual bool deactivate() = 0;
 
-    virtual bool draw() const;
+    virtual void draw() const;
 
     inline bool isActivated() const { return this->bActivated; }
Index: branches/network/src/lib/graphics/graphics_engine.cc
===================================================================
--- branches/network/src/lib/graphics/graphics_engine.cc	(revision 6776)
+++ branches/network/src/lib/graphics/graphics_engine.cc	(revision 6777)
@@ -41,4 +41,9 @@
 #include "shell_command.h"
 
+
+#include "parser/tinyxml/tinyxml.h"
+#include "load_param.h"
+#include "factory.h"
+
 #ifdef __WIN32__
  #include "class_list.h"
@@ -113,4 +118,16 @@
   GraphicsEngine::singletonRef = NULL;
 }
+
+
+/**
+ * loads the GraphicsEngine Specific Parameters.
+ * @param root: the XML-Element to load the Data From
+ */
+void GraphicsEngine::loadParams(const TiXmlElement* root)
+{
+  LoadParamXML(root, "load-effect", this, GraphicsEngine, loadGraphicsEffectXML)
+      .describe("loads a graphics effect");
+}
+
 
 /**
@@ -150,8 +167,8 @@
   this->initVideo(atoi(resolution.getString(0)), atoi(resolution.getString(1)), 16);
 
-  GraphicsEffect* fe = new FogEffect(NULL);
-  this->loadGraphicsEffect(fe);
-  fe->activate();
-  PRINTF(0)("--------------------------------------------------------------\n");
+//   GraphicsEffect* fe = new FogEffect(NULL);
+//   this->loadGraphicsEffect(fe);
+//   fe->activate();
+//   PRINTF(0)("--------------------------------------------------------------\n");
 }
 
@@ -665,4 +682,20 @@
 
 /**
+ * @param root The XML-element to load GraphicsEffects from
+ */
+void GraphicsEngine::loadGraphicsEffectXML(const TiXmlElement* root)
+{
+  const TiXmlElement* element = root->FirstChildElement();
+
+  while (element != NULL)
+  {
+    Factory::fabricate(element);
+
+    element = element->NextSiblingElement();
+  }
+}
+
+
+/**
  * loads a GraphicsEffect into the engine
  * @param effect the GraphicsEffect to add
Index: branches/network/src/lib/graphics/graphics_engine.h
===================================================================
--- branches/network/src/lib/graphics/graphics_engine.h	(revision 6776)
+++ branches/network/src/lib/graphics/graphics_engine.h	(revision 6777)
@@ -23,4 +23,5 @@
 class WorldEntity;
 class GraphicsEffect;
+class TiXmlElement;
 
 //! class to handle graphics
@@ -34,4 +35,6 @@
     /** @returns a Pointer to the only object of this Class */
     inline static GraphicsEngine* getInstance() { if (!GraphicsEngine::singletonRef) GraphicsEngine::singletonRef = new GraphicsEngine();  return GraphicsEngine::singletonRef; };
+
+    virtual void loadParams(const TiXmlElement* root);
 
     int init();
@@ -83,4 +86,5 @@
     void process(const Event  &event);
 
+    void loadGraphicsEffectXML(const TiXmlElement* root);
     bool loadGraphicsEffect(GraphicsEffect* effect);
     bool unloadGraphicsEffect(GraphicsEffect* effect);
Index: branches/network/src/story_entities/game_world_data.cc
===================================================================
--- branches/network/src/story_entities/game_world_data.cc	(revision 6776)
+++ branches/network/src/story_entities/game_world_data.cc	(revision 6777)
@@ -278,4 +278,5 @@
 {
   LoadParamXML(root, "LightManager", LightManager::getInstance(), LightManager, loadParams);
+  LoadParamXML(root, "GraphicsEngine", GraphicsEngine::getInstance(), GraphicsEngine, loadParams);
 
 //  LoadParamXML(root, "ParticleEngine", ParticleEngine::getInstance(), ParticleEngine, loadParams);