Index: code/branches/rocket/src/orxonox/controllers/AIController.cc
===================================================================
--- code/branches/rocket/src/orxonox/controllers/AIController.cc	(revision 6522)
+++ code/branches/rocket/src/orxonox/controllers/AIController.cc	(revision 6778)
@@ -57,17 +57,17 @@
 
         // search enemy
-        random = rnd(maxrand);
+      /*  random = rnd(maxrand);
         if (random < 15 && (!this->target_))
-            this->searchNewTarget();
+            this->searchNewTarget();*/
 
         // forget enemy
-        random = rnd(maxrand);
-        if (random < 5 && (this->target_))
-            this->forgetTarget();
+        //random = rnd(maxrand);
+        //if (random < 5 && (this->target_))
+        //    this->forgetTarget();
 
         // next enemy
-        random = rnd(maxrand);
+  /*      random = rnd(maxrand);
         if (random < 10 && (this->target_))
-            this->searchNewTarget();
+            this->searchNewTarget();*/
 
         // fly somewhere
@@ -87,12 +87,12 @@
 
         // shoot
-        random = rnd(maxrand);
-        if (random < 75 && (this->target_ && !this->bShooting_))
-            this->bShooting_ = true;
+        //random = rnd(maxrand);
+        //if (random < 75 && (this->target_ && !this->bShooting_))
+        //    this->bShooting_ = true;
 
-        // stop shooting
-        random = rnd(maxrand);
-        if (random < 25 && (this->bShooting_))
-            this->bShooting_ = false;
+        //// stop shooting
+        //random = rnd(maxrand);
+        //if (random < 25 && (this->bShooting_))
+        //    this->bShooting_ = false;
     }
 
Index: code/branches/rocket/src/orxonox/controllers/CMakeLists.txt
===================================================================
--- code/branches/rocket/src/orxonox/controllers/CMakeLists.txt	(revision 6522)
+++ code/branches/rocket/src/orxonox/controllers/CMakeLists.txt	(revision 6778)
@@ -8,3 +8,4 @@
   WaypointController.cc
   WaypointPatrolController.cc
+  RocketController.cc
 )
Index: code/branches/rocket/src/orxonox/controllers/DroneController.cc
===================================================================
--- code/branches/rocket/src/orxonox/controllers/DroneController.cc	(revision 6778)
+++ code/branches/rocket/src/orxonox/controllers/DroneController.cc	(revision 6778)
@@ -0,0 +1,77 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Oli Scheuss
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+#include "DroneController.h"
+#include "worldentities/Drone.h"
+#include "util/Math.h"
+
+
+namespace orxonox
+{
+    /**
+    @brief
+        Constructor.
+    */
+    DroneController::DroneController(BaseObject* creator) : Controller(creator)
+    {
+		RegisterObject(DroneController);
+        // Place your code here:
+        // - make sure to register the object in the factory
+        // - do any kind of initialisation
+        
+        // this checks that our creator really is a drone
+        // and saves the pointer to the drone for the controlling commands
+        assert(dynamic_cast<Drone*>(creator)!=0);
+        this->setControllableEntity(dynamic_cast<Drone*>(creator));
+    }
+
+    DroneController::~DroneController()
+    {
+    }
+
+    /**
+    @brief
+        The controlling happens here. This method defines what the controller has to do each tick.
+    @param dt
+        The duration of the tick.
+    */
+    void DroneController::tick(float dt)
+    {
+        // Place your code here:
+        // - steering commands
+        Drone *myDrone = static_cast<Drone*>(this->getControllableEntity());
+        // you can use the following commands for steering 
+        // - moveFrontBack, moveRightLeft, moveUpDown 
+        // - rotatePitch, rotateYaw, rotateRoll 
+        // - apply the to myDrone (e.g. myDrone->rotateYaw(..) ) 
+
+		myDrone->rotateYaw(0.2);
+		myDrone->moveFrontBack(2);
+
+    }
+}
Index: code/branches/rocket/src/orxonox/controllers/DroneController.h
===================================================================
--- code/branches/rocket/src/orxonox/controllers/DroneController.h	(revision 6778)
+++ code/branches/rocket/src/orxonox/controllers/DroneController.h	(revision 6778)
@@ -0,0 +1,59 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Oli Scheuss
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+#ifndef _DroneController_H__
+#define _DroneController_H__
+
+#include "OrxonoxPrereqs.h"
+
+#include "Controller.h"
+#include "tools/interfaces/Tickable.h"
+
+namespace orxonox
+{
+    /**
+    @brief
+        Controller for the Drone of the PPS tutorial.
+    @author
+        Oli Scheuss
+    */
+    class _OrxonoxExport DroneController : public Controller, public Tickable
+    {
+        public:
+            DroneController(BaseObject* creator);
+            virtual ~DroneController();
+            
+            virtual void tick(float dt); //!< The controlling happens here. This method defines what the controller has to do each tick.
+
+        protected:
+
+        private:
+    };
+}
+
+#endif /* _DroneController_H__ */
Index: code/branches/rocket/src/orxonox/controllers/RocketController.cc
===================================================================
--- code/branches/rocket/src/orxonox/controllers/RocketController.cc	(revision 6778)
+++ code/branches/rocket/src/orxonox/controllers/RocketController.cc	(revision 6778)
@@ -0,0 +1,74 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Oli Scheuss
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+#include "RocketController.h"
+#include "modules\weapons\projectiles\SimpleRocket.h"
+#include "util/Math.h"
+
+
+namespace orxonox
+{
+    /**
+    @brief
+        Constructor.
+    */
+    RocketController::RocketController(BaseObject* creator) : Controller(creator)
+    {
+        // Place your code here:
+        // - make sure to register the object in the factory
+        // - do any kind of initialisation
+        RegisterObject(RocketController);
+        // this checks that our creator really is a drone
+        // and saves the pointer to the drone for the controlling commands
+    }
+
+    RocketController::~RocketController()
+    {
+    }
+
+    /**
+    @brief
+        The controlling happens here. This method defines what the controller has to do each tick.
+    @param dt
+        The duration of the tick.
+    */
+    void RocketController::tick(float dt)
+    {
+        // Place your code here:
+        // - steering commands
+        SimpleRocket* rocket = static_cast<SimpleRocket>(this->getControllableEntity());
+        // you can use the following commands for steering 
+        // - moveFrontBack, moveRightLeft, moveUpDown 
+        // - rotatePitch, rotateYaw, rotateRoll 
+        // - apply the to myDrone (e.g. myDrone->rotateYaw(..) ) 
+
+		rocket->rotateYaw(0.2);
+			rocket->moveFrontBack(2);
+
+    }
+}
Index: code/branches/rocket/src/orxonox/controllers/RocketController.h
===================================================================
--- code/branches/rocket/src/orxonox/controllers/RocketController.h	(revision 6778)
+++ code/branches/rocket/src/orxonox/controllers/RocketController.h	(revision 6778)
@@ -0,0 +1,59 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Oli Scheuss
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+#ifndef _RocketController_H__
+#define _RocketController_H__
+
+#include "OrxonoxPrereqs.h"
+
+#include "Controller.h"
+#include "tools/interfaces/Tickable.h"
+
+namespace orxonox
+{
+    /**
+    @brief
+        Controller for the Drone of the PPS tutorial.
+    @author
+        Oli Scheuss
+    */
+    class _OrxonoxExport RocketController : public Controller, public Tickable
+    {
+        public:
+            RocketController(BaseObject* creator);
+            virtual ~RocketController();
+            
+            virtual void tick(float dt); //!< The controlling happens here. This method defines what the controller has to do each tick.
+
+        protected:
+
+        private:
+    };
+}
+
+#endif /* _RocketController_H__ */